/*
 * KresliciPlocha.java
 *
 * Created on 27. jen 2006, 11:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package hracka;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *
 * @author Miroslav Balk
 * Tato tda reprezentuje kreslc plochu. Zkladn metoda pro vykreslovn je metoda paint,
  kter m jako parametr Graphics g. Ostatn metody umouj dlat obsluhy jednotlivch udlost klvesnice 
 a myi
 */
public class KresliciPlocha extends JToggleButton{
     int hloubka = 1;
    /** konstruktor, nastaveni ovladani
     */
    public KresliciPlocha(){
       super();
       setBorderPainted(false);//nechceme kreslit ohrani4en9
       setContentAreaFilled(false);//bez vyplne
//       this.setBackground(new Color(0,0,255)); //nastaveni barvy pozadi na barvu modrou - slozky r,g,b
       aktivujAkciKlaves();
       aktivujAkciMysi();
       }
    private void aktivujAkciKlaves(){
       addKeyListener(new KeyAdapter() {
            public void keyPressed(KeyEvent evt) {
                klavesaDolu(evt);
            }
            public void keyReleased(KeyEvent evt) {
                klavesaNahoru(evt);
            }            
        });      
    }
    private void aktivujAkciMysi(){
        addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent evt) {
                mysDolu(evt);
            }
            public void mouseReleased(MouseEvent evt) {
                mysNahoru(evt);
            }

        });    
    }
    /** Metoda, ktera bude volana pokud nekdo stiskne klavesu
     * takto jednodue poznte jak klvesa byla stisknuta
     */
    public void klavesaDolu(KeyEvent evt){
        System.out.println("Stisknuta klavesa "+ evt.getKeyCode());
        
    }

    /** metoda, ktera obsluhuje klavesu nahoru
     */
    public void klavesaNahoru(KeyEvent evt){
        System.out.println("Pustena klavesa "+ evt.getKeyCode());
    }
    /** Systm zavol tuto metodu pokud nkdo stiskne libovoln tlatko myi
     nad kreslc plochou
     *
     */
    public void mysDolu(MouseEvent e){
        hloubka ++;
        System.out.println("Mys dolu na pozici " + e.getX()+ " "+e.getY()+" tlacitka: 1:" + (( e.getButton () & MouseEvent.BUTTON1 ) != 0 ) + 
                           " 2:" + (( e.getButton () & MouseEvent.BUTTON2 ) != 0 ));
    }
    public void mysNahoru(MouseEvent e){
        System.out.println("Mys nahoru na pozici " + e.getX()+ " "+e.getY());
    }
    
    public Point getStred(Point a, Point b){
        return new Point((a.x+b.x)/2,(a.y+b.y)/2);
    }
    
    public void kresliTrojuhelnik(Graphics g, int pocetZanoreni, Point a, Point b, Point c){
        g.drawLine(a.x,a.y,b.x,b.y);
        g.drawLine(b.x,b.y,c.x,c.y);
        g.drawLine(a.x,a.y,c.x,c.y);
        if(pocetZanoreni>1){
            kresliTrojuhelnik(g,pocetZanoreni-1,a, getStred(a,b),getStred(a,c));
            kresliTrojuhelnik(g,pocetZanoreni-1,b, getStred(a,b),getStred(b,c));
            kresliTrojuhelnik(g,pocetZanoreni-1,c, getStred(b,c),getStred(a,c));
         ///   kresliTrojuhelnik(g,pocetZanoreni-1,getStred(a,b), getStred(b,c),getStred(a,c));
            
        }
    }
    
    public void paintComponent(Graphics g){
        super.paintComponent(g);
        //g.drawOval(10,10,100,200);
        System.out.println("Hloubka zanoreni "+ hloubka);
        int sirka = this.getWidth();
        int vyska = this.getHeight();
        kresliTrojuhelnik(g,hloubka,new Point(sirka/2-1,1),new Point(1,vyska-1),new Point(sirka-1,vyska-1));
    }
           
}
